VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4200
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3870
   LinkTopic       =   "Form1"
   ScaleHeight     =   4200
   ScaleWidth      =   3870
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox btnControl 
      BackColor       =   &H00C0C0FF&
      BorderStyle     =   0  'None
      Height          =   480
      Left            =   1605
      ScaleHeight     =   32
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   37
      TabIndex        =   0
      Top             =   3645
      Width           =   555
   End
   Begin VB.Label Label1 
      Caption         =   "Button With Events"
      Height          =   255
      Left            =   1140
      TabIndex        =   1
      Top             =   3315
      Width           =   2010
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function DrawFrameControl Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long

' Frame type.
Private Const DFC_BUTTON = 4
Private Const DFC_CAPTION = 1
Private Const DFC_MENU = 2
Private Const DFC_POPUPMENU = 5
Private Const DFC_SCROLL = 3

' Frame states.
' DFC_BUTTON
Private Const DFCS_BUTTON3STATE = &H8
Private Const DFCS_BUTTONCHECK = &H0
Private Const DFCS_BUTTONPUSH = &H10
Private Const DFCS_BUTTONRADIO = &H4
Private Const DFCS_BUTTONRADIOIMAGE = &H1
Private Const DFCS_BUTTONRADIOMASK = &H2

' DFC_CAPTION
Private Const DFCS_CAPTIONCLOSE = &H0
Private Const DFCS_CAPTIONHELP = &H4
Private Const DFCS_CAPTIONMAX = &H2
Private Const DFCS_CAPTIONMIN = &H1
Private Const DFCS_CAPTIONRESTORE = &H3

' DFC_MENU
Private Const DFCS_MENUARROW = &H0
Private Const DFCS_MENUARROWRIGHT = &H4
Private Const DFCS_MENUBULLET = &H2
Private Const DFCS_MENUCHECK = &H1

' DFC_SCROLL
Private Const DFCS_SCROLLCOMBOBOX = &H5
Private Const DFCS_SCROLLDOWN = &H1
Private Const DFCS_SCROLLLEFT = &H2
Private Const DFCS_SCROLLRIGHT = &H3
Private Const DFCS_SCROLLSIZEGRIP = &H8
Private Const DFCS_SCROLLSIZEGRIPRIGHT = &H10
Private Const DFCS_SCROLLUP = &H0

Private Const DFCS_ADJUSTRECT = &H2000

' Statuses.
Private Const DFCS_CHECKED = &H400
Private Const DFCS_FLAT = &H4000
Private Const DFCS_HOT = &H1000
Private Const DFCS_INACTIVE = &H100
Private Const DFCS_MONO = &H8000
Private Const DFCS_PUSHED = &H200
Private Const DFCS_TRANSPARENT = &H800
' Draw a frame control image.
Private Sub DrawFrame(ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal wid As Long, ByVal hgt As Long, ByVal frame_type As Long, ByVal frame_state As Long, Optional ByVal frame_status As Long = 0)
Dim r As RECT

    With r
        .Left = X
        .Right = X + wid
        .Top = Y
        .Bottom = Y + hgt
    End With

    DrawFrameControl hDC, r, frame_type, frame_state Or frame_status
End Sub

Private Sub btnControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    btnControl.Picture = LoadPicture()
    DrawFrame btnControl.hDC, 0, 0, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE, DFCS_CHECKED
End Sub

Private Sub btnControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    btnControl.Picture = LoadPicture()
    DrawFrame btnControl.hDC, 0, 0, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE
End Sub

Private Sub Form_Load()
Dim Y As Long
    AutoRedraw = True
    ScaleMode = vbPixels

With btnControl
    .BackColor = vbYellow
    .AutoRedraw = True
    .Width = 16
    .Height = 14
    .Visible = True
End With
DrawFrame btnControl.hDC, 0, 0, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE

    Y = 10
    CurrentX = 30
    CurrentY = Y
    Print "Normal"
    DrawFrame hDC, 110, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE
    DrawFrame hDC, 130, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONRESTORE
    DrawFrame hDC, 150, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMIN
    DrawFrame hDC, 170, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMAX
    DrawFrame hDC, 190, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONHELP

    Y = Y + 20
    CurrentX = 30
    CurrentY = Y
    Print "Inactive"
    DrawFrame hDC, 110, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE, DFCS_INACTIVE
    DrawFrame hDC, 130, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONRESTORE, DFCS_INACTIVE
    DrawFrame hDC, 150, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMIN, DFCS_INACTIVE
    DrawFrame hDC, 170, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMAX, DFCS_INACTIVE
    DrawFrame hDC, 190, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONHELP, DFCS_INACTIVE

    Y = Y + 20
    CurrentX = 30
    CurrentY = Y
    Print "Flat"
    DrawFrame hDC, 110, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE, DFCS_FLAT
    DrawFrame hDC, 130, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONRESTORE, DFCS_FLAT
    DrawFrame hDC, 150, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMIN, DFCS_FLAT
    DrawFrame hDC, 170, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMAX, DFCS_FLAT
    DrawFrame hDC, 190, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONHELP, DFCS_FLAT

    Y = Y + 20
    CurrentX = 30
    CurrentY = Y
    Print "Checked"
    DrawFrame hDC, 110, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE, DFCS_CHECKED
    DrawFrame hDC, 130, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONRESTORE, DFCS_CHECKED
    DrawFrame hDC, 150, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMIN, DFCS_CHECKED
    DrawFrame hDC, 170, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMAX, DFCS_CHECKED
    DrawFrame hDC, 190, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONHELP, DFCS_CHECKED

    Y = Y + 20
    CurrentX = 30
    CurrentY = Y
    Print "Hot"
    DrawFrame hDC, 110, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE, DFCS_HOT
    DrawFrame hDC, 130, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONRESTORE, DFCS_HOT
    DrawFrame hDC, 150, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMIN, DFCS_HOT
    DrawFrame hDC, 170, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMAX, DFCS_HOT
    DrawFrame hDC, 190, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONHELP, DFCS_HOT

    Y = Y + 20
    CurrentX = 30
    CurrentY = Y
    Print "Mono"
    DrawFrame hDC, 110, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONCLOSE, DFCS_MONO
    DrawFrame hDC, 130, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONRESTORE, DFCS_MONO
    DrawFrame hDC, 150, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMIN, DFCS_MONO
    DrawFrame hDC, 170, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONMAX, DFCS_MONO
    DrawFrame hDC, 190, Y, 16, 14, DFC_CAPTION, DFCS_CAPTIONHELP, DFCS_MONO

    Y = Y + 40
    CurrentX = 30
    CurrentY = Y
    Print "Buttons"
    DrawFrame hDC, 110, Y, 16, 14, DFC_BUTTON, DFCS_BUTTON3STATE
    DrawFrame hDC, 130, Y, 16, 14, DFC_BUTTON, DFCS_BUTTONCHECK
    DrawFrame hDC, 150, Y, 16, 14, DFC_BUTTON, DFCS_BUTTONPUSH
    DrawFrame hDC, 170, Y, 16, 14, DFC_BUTTON, DFCS_BUTTONRADIO
    DrawFrame hDC, 190, Y, 16, 14, DFC_BUTTON, DFCS_BUTTONRADIOIMAGE
    DrawFrame hDC, 210, Y, 16, 14, DFC_BUTTON, DFCS_BUTTONRADIOMASK

    Y = Y + 20
    CurrentX = 30
    CurrentY = Y
    Print "Menus"
    DrawFrame hDC, 110, Y, 16, 14, DFC_MENU, DFCS_MENUARROW
    DrawFrame hDC, 130, Y, 16, 14, DFC_MENU, DFCS_MENUARROWRIGHT
    DrawFrame hDC, 150, Y, 16, 14, DFC_MENU, DFCS_MENUBULLET
    DrawFrame hDC, 170, Y, 16, 14, DFC_MENU, DFCS_MENUCHECK

    Y = Y + 20
    CurrentX = 30
    CurrentY = Y
    Print "Scroll"
    DrawFrame hDC, 110, Y, 16, 14, DFC_SCROLL, DFCS_SCROLLCOMBOBOX
    DrawFrame hDC, 130, Y, 16, 14, DFC_SCROLL, DFCS_SCROLLDOWN
    DrawFrame hDC, 150, Y, 16, 14, DFC_SCROLL, DFCS_SCROLLLEFT
    DrawFrame hDC, 170, Y, 16, 14, DFC_SCROLL, DFCS_SCROLLRIGHT
    DrawFrame hDC, 190, Y, 16, 14, DFC_SCROLL, DFCS_SCROLLSIZEGRIP
    DrawFrame hDC, 210, Y, 16, 14, DFC_SCROLL, DFCS_SCROLLSIZEGRIPRIGHT
    DrawFrame hDC, 230, Y, 16, 14, DFC_SCROLL, DFCS_SCROLLUP
End Sub
